package rocks.zipcode;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.*;
import java.util.Arrays;
import java.util.List;

/**
 * @author leon on 16/11/2018.
 */
public class Document implements DocumentInterface {

    private final FileWriter fileWriter;
    private final File file;

    public Document(String fileName) throws IOException {
        this(new File(fileName));
    }

    public Document(File file) throws IOException {
        this.file = file;
        this.fileWriter = new FileWriter(file);
    }

    @Override
    public void write(String contentToBeWritten) {
        try{
            fileWriter.write(contentToBeWritten);
            fileWriter.flush();
            fileWriter.close();

        } catch (IOException io) {
            io.printStackTrace();
        }
    }

    @Override
    public void write(Integer lineNumber, String valueToBeWritten){

    }

    @Override
    public String read(Integer lineNumber) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(file));
        String stringAtLineNumber;
        int i = 0;
        do{
            stringAtLineNumber = br.readLine();
            i++;

        } while (i <= lineNumber);
        return stringAtLineNumber;
    }

    @Override
    public String read() throws IOException{
        BufferedReader readFile = new BufferedReader(new FileReader(file));
        String fileAsString;
        try {
            StringBuilder sb = new StringBuilder();
            String fileLine = readFile.readLine();

            while (fileLine != null) {
                sb.append(fileLine);
                sb.append(System.lineSeparator());
                fileLine = readFile.readLine();
            }
            fileAsString  = sb.toString().trim();

        } finally {
            readFile.close();
        }

        return fileAsString;

    }

    @Override
    public void replaceAll(String stringToReplace, String replacementString) {
    }

    @Override
    public void overWrite(String content) {

    }

    public List<String> toList() {
        return null;
    }

    @Override
    public File getFile() {
        return file;
    }

    @Override
    public String toString() {
        return null;
    }
}
